#include <stdio.h>
#include "interface.h"

/* SCOUT compatible! */

extern SensorType Sensors;

// find the simplified delta-angle from one heading to another.
int DiffAng(int dest, int src)
{
	// Note that INTABS is a macro defined in useful.h that finds the
	// absolute value of an integer.  There are a few other macros there
	// that you may find useful.  
	if (INTABS(dest-src) <= 1800)
		return dest-src;
	dest = (dest + 1800) % 3600;
	src = (src + 1800) % 3600;
	return dest-src;
}

// turn turnang tenths of a degree from the current heading.
void Turn(int turnang)
{
	int deltaang, intang, ang, goalang, done, rv;

	intang = ang = Sensors.angle;
	goalang = (ang + turnang) % 3600;
	deltaang = 0;

	done = 0;
	while (!done) {
		rv = DiffAng(goalang, ang) / 8;
		RMove(rv, (-rv));
		ang = Sensors.angle;
		done = (INTABS(goalang - ang) < 15) && (INTABS(Sensors.rVel) < 60);
	}
	RMove(0,0);
}

int RobotMain()
{
	char buf[256];
	char mytxt[256];
	int bumpf,bumpb;
	
	GS(); // make sure that Sensors is up-to-date.
	SonarsOn();
	Sleep(1000);
	GS();
		// Speak("c:\\sounds\\examples\\name.wav");
		//RMove(-20,-20);
	Turn(900);
	OutputText("Please type something in the input box and hit <Enter>.\n");
	GetLineInputBox(buf);
	OutputText("You just typed:\n");
	OutputText(buf);
	OutputText("\nNow please exit the keyboard control then hit the Foo button.\n");
	GetFooClick();
	KeybdControl();
	while (!GetFooClick()) {
		RMove(0,0);
		Sleep(500);
		bumpb = (int) (((long) 8) & ((long)Sensors.bumper));
		bumpf = (int) (((long)1) & ((long)Sensors.bumper));
//		sprintf(mytxt, "bumper: %f front: %d rear: %d\n", 
//			Sensors.bumper, bumpf, bumpb);
		sprintf(mytxt, "rvelocity %d lvelocity %d\n",
			Sensors.rVel, Sensors.lVel);
		OutputText(mytxt);
	}
	SonarsOff();
	SonarsOff();
		
//	Speak("c:\\sounds\\examples\\foo.wav");
	OutputText("\nThat\'s all, folks!\n");
	Sleep(500);
	
	return 0;
}

